package main

import (
	"errors"
	"fmt"
)

type ErrorString struct {
	s string
}

func (e *ErrorString) Error() string {
	return e.s
}

func main() {
	err1 := errors.New("new error")
	err2 := fmt.Errorf("err2: [%w]", err1)
	err3 := fmt.Errorf("err3: [%w]", err2)
	fmt.Println(err3)

	// unwrap
	fmt.Println(errors.Unwrap(err3))
	fmt.Println(errors.Unwrap(errors.Unwrap(err3)))

	// errors.Is
	fmt.Println(errors.Is(err3, err2))
	fmt.Println(errors.Is(err3, err1))

	// errors.As
	var targetErr *ErrorString
	err := fmt.Errorf("new error:[%w]", &ErrorString{s: "target err"})
	fmt.Println(errors.As(err, &targetErr))

	// Output:
	//err3: [err2: [new error]]
	//err2: [new error]
	//new error
	//true
	//true
	//true
}
